freeslot("MT_FAKESPRITE", "S_PLAY_DUMMYSTATE", "MT_SPHEREINV", "S_SPHEREINV", "SPR_INVR")

states[S_SPHEREINV] = {
	sprite = SPR_INVR,
	frame = FF_FULLBRIGHT|FF_SUBTRACT|FF_TRANS50|A,
	tics = TICRATE/2,
	action = nil,
	var1 = 0,
	var2 = 0,
	nextstate = S_NULL
}

states[S_PLAY_DUMMYSTATE] = {
	sprite = SPR_PLAY,
	frame = SPR2_STND,
	tics = -1,
	action = nil,
	var1 = 0,
	var2 = 0,
	nextstate = S_NULL
}

mobjinfo[MT_SPHEREINV] = {
	doomednum = -1,
	spawnstate = S_SPHEREINV,
	dispoffset = -1,
	flags = MF_NOBLOCKMAP|MF_NOGRAVITY|MF_NOCLIP|MF_NOCLIPHEIGHT
}

mobjinfo[MT_FAKESPRITE] = {
	doomednum = -1,
	spawnstate = S_PLAY_DUMMYSTATE,
	dispoffset = 0,
	flags = MF_NOBLOCKMAP|MF_NOCLIP|MF_NOCLIPHEIGHT
}

local function IsPlayerMobj(p)
	return p and p.valid and p.mo and p.mo.valid
end

local function IsMobjPlayer(mobj)
	return mobj and mobj.valid and mobj.player and mobj.player.valid
end

local function IsPlayerAlive(p)
	return IsPlayerMobj(p) and p.mo.health > 0 and p.playerstate ~= PST_DEAD and p.mo.gmGhost == nil
end

local function StopMove(mobj)
	mobj.momx = 0
	mobj.momy = 0
	mobj.momz = 0
end

local function ReviveGhost(ghost, savior)
	if IsPlayerMobj(ghost) then
	
		if not ghost.gmGhost then return end

		S_StartSound(ghost.mo, sfx_hidden)
		
		ghost.gmGhost.revive = TICRATE + 1
		ghost.gmGhost.framemem = ghost.mo.frame & ~FF_TRANS50
		ghost.gmGhost.freezeframe = P_SpawnMobjFromMobj(ghost.mo, ghost.mo.momx, ghost.mo.momy, ghost.mo.momz, MT_FAKESPRITE)
		ghost.gmGhost.freezeframe.angle = ghost.drawangle
		ghost.gmGhost.freezeframe.skin = ghost.mo.skin
		ghost.gmGhost.freezeframe.color = ghost.mo.color
		ghost.gmGhost.freezeframe.frame = ghost.mo.frame
		ghost.gmGhost.freezeframe.sprite2 = ghost.mo.sprite2
		A_SetObjectFlags(ghost.gmGhost.freezeframe, MF_NOGRAVITY, 2)
		ghost.mo.flags2 = $|MF2_DONTDRAW
		
		local invRing = P_SpawnMobjFromMobj(ghost.mo, ghost.mo.momx, ghost.mo.momy, ghost.mo.momz + ghost.mo.height/2, MT_SPHEREINV)
		invRing.scale = 0
		invRing.tics = TICRATE
		invRing.destscale = FU
		invRing.scalespeed = FU/(TICRATE/2)
		
		invRing = P_SpawnMobjFromMobj(ghost.mo, ghost.mo.momx, ghost.mo.momy, ghost.mo.momz + ghost.mo.height/2, MT_SPHEREINV)
		invRing.scale = 0
		invRing.tics = TICRATE
		invRing.destscale = FU
		invRing.scalespeed = FU/(TICRATE/3*2)
	end
end

COM_AddCommand("ghost_revive", function(p, playernum)
	if playernum and tonumber(playernum) then
		ReviveGhost(players[tonumber(playernum)], p) 
	else
		ReviveGhost(p, p) 
	end
end, COM_ADMIN)

addHook("PlayerSpawn", function(p)
	if p.valid then
		if p.gmGhost then
			p.gmGhost = nil
		end
		
	end
end)

addHook("PlayerThink", function(p)

	if IsPlayerMobj(p) and p.gmGhost and p.gmGhost.revive then
		
		if p.gmGhost.revive == 1 then
			p.mo.flags2 = $ & ~MF2_DONTDRAW
			p.mo.frame = $ & ~FF_TRANS50
			p.mo.color = p.skincolor
			P_RemoveMobj(p.gmGhost.freezeframe)
			p.gmGhost = nil
			return
		end
		
		StopMove(p.mo)
		p.gmGhost.revive = $-1
	end
end)

addHook("PostThinkFrame", function()
	for p in players.iterate do
		if IsPlayerMobj(p) and p.gmGhost then
			
			p.powers[pw_shield] = 0
			p.powers[pw_underwater] = TICRATE*30
			p.rings = 0
			
			if p.gmGhost.revive > 1 and p.gmGhost.freezeframe and p.gmGhost.freezeframe.valid then
				
				p.mo.flags2 = $|MF2_DONTDRAW
				
				if p.gmGhost.revive < TICRATE/5 + 1 then
					p.gmGhost.freezeframe.frame = p.gmGhost.framemem|FF_TRANS10
				elseif p.gmGhost.revive < TICRATE/5*2 + 1 then
					p.gmGhost.freezeframe.frame = p.gmGhost.framemem|FF_TRANS20	
					p.gmGhost.freezeframe.color = p.skincolor
				elseif p.gmGhost.revive < TICRATE/5*3 + 1 then -- bruh
					p.gmGhost.freezeframe.frame = p.gmGhost.framemem|FF_TRANS30
				elseif p.gmGhost.revive < TICRATE/5*4 + 1 then
					p.gmGhost.freezeframe.frame = p.gmGhost.framemem|FF_TRANS40
				else
					p.gmGhost.freezeframe.frame = p.gmGhost.framemem|FF_TRANS50
				end
				
				return
			end
			
			if not p.gmGhost.revive then
			
				p.mo.frame = $|FF_TRANS50
				p.mo.color = SKINCOLOR_CLOUDY
			
			end
		end
	end
end)

addHook("MobjDeath", function(mobj, inflictor, source, dt)

	if IsMobjPlayer(mobj) and mobj.player.gmGhost == nil and not (dt == DMG_DEATHPIT or dt == DMG_CRUSHED) then
		
		local p = mobj.player
		
		p.gmGhost = {
			revive = 0,
			freezeframe = nil
		}

			
		local fakeDead = P_SpawnMobjFromMobj(mobj, 0, 0, 0, MT_FAKESPRITE)
		fakeDead.skin = mobj.skin
		fakeDead.color = mobj.color
		fakeDead.state = S_PLAY_DEAD
		fakeDead.momz = 12*FU
		fakeDead.fuse = TICRATE*10
		
		S_StartSound(fakeDead, sfx_cdfm03)
		P_DoPlayerPain(p, source, inflictor)
		A_SetObjectFlags(mobj, MF_SHOOTABLE, 2)
		
		mobj.color = SKINCOLOR_CLOUDY
		mobj.health = 1
		
		return true
		
	end
	
	return
end, MT_PLAYER)

addHook("MobjDamage", function(mobj, inflictor, source, damage, dt)
	if IsMobjPlayer(inflictor) then
		if inflictor.player.gmGhost then return true end
	elseif IsMobjPlayer(source) then
		if source.player.gmGhost then return true end
	end
end, MT_NULL)

addHook("PlayerCanDamage", function(p, mobj)
	if IsPlayerMobj(p) and mobj.valid and p.gmGhost and (mobj.flags & MF_MONITOR) then return false end
	return
end)

addHook("TouchSpecial", function(sMobj, mobj)
	if IsMobjPlayer(mobj) and mobj.player.gmGhost then
		return true
	end
end, MT_RING)

addHook("TouchSpecial", function(sMobj, mobj)
	if IsMobjPlayer(mobj) and mobj.player.gmGhost then
		return true
	end
end, MT_STARPOST)

addHook("MobjCollide", function(mobj, moverMobj)
	if IsMobjPlayer(mobj) and IsMobjPlayer(moverMobj)
		if IsPlayerAlive(mobj.player) and moverMobj.player.gmGhost and not moverMobj.player.gmGhost.revive and not moverMobj.player.powers[pw_flashing] then
			ReviveGhost(moverMobj.player, mobj.player)
		elseif IsPlayerAlive(moverMobj.player) and mobj.player.gmGhost and not mobj.player.gmGhost.revive and not mobj.player.powers[pw_flashing] then
			ReviveGhost(mobj.player, moverMobj.player)
		end
		
	end
end, MT_PLAYER)